#Compile   Exe   "test.exe"
#Compiler   PBWin   10,   PBCC   6
#Dim    All

#If   %Def   (   %debugging  )
#Messages   Command
Macro   MyDebugger  ()
	#Debug   Print   "Debuggin"
End    Macro
#Tools On
#Else
#Tools Off
#Messages   Notify
Macro   MyDebugger()
End   Macro
#EndIf

Enum   myEnum
	a
	b
End   Enum

Enum   _
			myEnum2
	a
	b
End   _
		Enum

Union myUnion2
	a  As Long
	b     As      Long
End Union

Union   _
			myUnion2
	a   _
			As   _
			Long
	b   _
			As   _
			Long
End _
		Union

Type    myType
	a    As     Long
	b    As     Long
End Type

Type    _
			myType2
	a    _
			As     _
			Long
	b    _
			As     _
			Long
End _
		Type

%compile = 1
%compile2 _
		= _
		2
$data    = "test"
$data2 _
		= _
		"test"


#Align 4
Function PBMain () As Long
	Local i As Long, _
			j As Long, _
			k As Long
	Local myData As myType

	Select Case Const i
		Case 0: Incr i: _ ' Note on line
					Incr j _
					: Incr k
		Case 1:
			If j=2 Then Incr k Else Incr j: _
					Incr i
		Case 2:
		Case 3:
			End
		Case Else
	End Select

	Prefix "!"
		mov eax, eax
	End Prefix
	!mov eax, eax
	Try
	Catch
	Finally
	End Try

	Try
		Error 1
		If -1 Then Exit Try
	Catch
		#Debug Print "caught"
		If -1 Then
			Exit Try
		End If
	Finally
		#Debug Print "Finally!"
	End Try

	#Debug Print "testing"
	If -1 Then
		#Debug Print "Yes!"
	End If

	If 0 Then
		#Debug Print "True"
	ElseIf -1 Then
	Else
		#Debug Print "Else"
	End If

	If 0 Then
	End If

	Type Set myData = Repeat$( SizeOf( myData ), Chr$( 0 ) )
	Type _
			Set _
			myData _
			= _
			Repeat$ _
			( _
			SizeOf( _
			myData _
			) _
			, _
			Chr$ _
			( _
			0 _
			) _
			)

	If 0 Then testLabel
	If 0 GoTo testLabel
	If 0 Then GoTo testLabel
testLabel:

	Do While 0
	Loop
	Do Until -1
	Loop

	Do While 0: Loop
	Do Until -1: Loop
	Do: Loop
	Do
	Loop
	Do
	Loop Until -1
	Do
	Loop While 0
	Do: Loop Until -1
	Do: Loop While -1
	Do While i<5
		Incr i
	Loop

	' Does nothing, no longer supported, yay!
	'for j=1 to 5 step -1
	'  for k=1 to 5 step 1
	'    incr i
	'  next j, k

	For j=1 To 5
		For k=1 To 5 Step 1
			Incr i
		Next j
	Next k

	While 0
	Wend
	While 0: Wend
	While 0
		Incr i
	Wend



End Function

' Empty fastProc
FastProc MyFastProc( ByVal a As Long ) As Long
End FastProc = a
'Statements in fastproc
FastProc myFastProc2( ByVal a As Long ) As Long
	Incr a
	End
End FastProc = a
' continuation fastproc
FastProc _
			MyFastProc3 _
			( _
			ByVal _
			a _
			As _
			Long _
			) _
			As _
			Long
End _
		FastProc _
		= _
		a



Function MyFunction() As Long
End Function
Function MyFunction2() As Long
	Function = 5
	End
End Function
Function _
			MyFunction3 _
			( _
			) _
			As _
			Long
	Function _
			= _
			5
End _
		Function
' Multiple single line function
Function MyFunction4() As Long: Function = 4: End Function: Function MyFunction5() As Long: Function = 5: End Function
' Single single line function
Function MyFunction6() As Long: Function = 6: End Function

CallBack Function MyCallbackFunction() As Long
End Function
CallBack Function functionMyCallbackFunction2() As Long
	Function = -1
End Function
CallBack _
			Function _
			MyCallbackFunction3 _
			( _
			) _
			As _
			Long
	Function _
			= _
			-1
End _
		Function
' Multiple single line function
CallBack Function MyCallBackFunction4() As Long: Function = 4: End Function: CallBack Function MyCallbackFunction5() As Long: Function = 5: End Function
' Single single line function
CallBack Function MyCallbackFunction6() As Long: Function = 6: End Function


Thread Function MyThreadFunction ( ByVal x As Long ) As Long
End Function
Thread Function MyThreadFunction2 ( ByVal x As Long ) As Long
	Function = x
End Function
Thread _
			Function _
			MyThreadFunction3 _
			( _
			ByVal _
			x _
			As _
			Long _
			) _
			As _
			Long
End _
		Function
' Multiple single line function
Thread Function MyThreadFunction4() As Long: Function = 4: End Function: Thread Function MyThreadFunction5() As Long: Function = 5: End Function
' Single single line function
Thread Function MyThreadFunction6() As Long: Function = 6: End Function

' stuff in asmdata
AsmData myAsmData
	DB &H00
End AsmData
' Empty asmdata
AsmData myasmdata2
End AsmData
' continuation asmdata
AsmData _
			myasmdata3
	DB _
			&H00
End _
		AsmData


Class cMyClass
	Instance x As Long
	Class Method Create()
	End Method
	Class Method MyClassMethod()
	End Method
	Interface iMyClass
		Inherit IUnknown
		Method MyMethod ( ) As Long
		End Method
		Method MyMethod2 ( ) As Long
			Method = 5
		End Method
		Method _
					MyMethod3 _
					( _
					) _
					As _
					Long
		End _
				Method
		Property Get MyProperty ( ) As Long
		End Property
		Property Get MyProperty2 ( ) As Long
			Property = 5
		End Property
		Property _
					Get _
					MyProperty3 _
					( _
					) _
					As _
					Long
			Property _
					= _
					5
		End _
				Property
	End Interface
	Class Method Destroy()
	End Method
	Class Method MyClassMethod2() As Long
		Method = 5
	End Method
End Class

Class cMyClass2
	Interface iMyClass2
		Inherit cMyClass, iMyClass
		Override Method MyMethod() As Long
		End Method
		Override Method MyMethod2() As Long
			Method = -2
		End Method
		Override _
					Method _
					MyMethod3 _
					( _
					) _
					As _
					Long
			Method _
					= _
					5
		End _
				Method
	End Interface
End Class



' empty sub
Sub MySub()
End Sub
' stuff in sub
Sub MySub2( a As Long )
	Incr a
End Sub
' continuation sub
Sub _
			mysub3 _
			( _
			a _
			As _
			Long _
			)
	End
End _
		Sub

' Multiple single line subs
Sub MySub5(): End Sub: Sub MySub6( a As Long ): Incr a: End Sub
' single single line sub
Sub MySub7(): End Sub

' Leading continuation, put this last because it's not working currently
_
	_
		Sub MySub4()
		End Sub
